/*   Q U I C K S O R T     
 *
 * Reference: Bhatt, Diks, Hagerup, Prasad, Saxena, Radzik:
 *            Improved Deterministic Parallel Integer Sorting.
 *            Information and Computation, to appear.
 */

#include <fork.h>
#include <assert.h>
#include <io.h>
 
sync void quicksort( sh int *);
void pra( void );

pr int wert, pos = 0;
#define Nmax 16    /* We need as many processors as there are 
                    * array elements in a[] to be sorted.  */
sh int a[] = { 5, 7, 3, 2, 17, 9, 4, 23, 0, 11, 19, 8, 14, 33, 2, 38 };

main(){
  start { 
    sh int gewicht;
    farm assert ( __STARTED_PROCS__ <= Nmax );
    wert = a[$];
    farm if ($==0) prS("unsorted:\n");
    farm pra();                           /* print unsorted array */
    quicksort( &gewicht );
    a[pos-1] = wert;
    farm if ($==0) prS("sorted:\n");
    farm pra();                           /* print sorted array */
  }
}

sync void quicksort( sh int *gewicht ) {
  sh int mitte, linksgewicht = 0, rechtsgewicht = 0;
  pr int links, rechts;
  mitte = wert;
  links =  wert < mitte; 
  rechts = (wert > mitte); 
  if (wert != mitte)
     if (links)  quicksort( &linksgewicht );
     else        quicksort( &rechtsgewicht );
  if (wert == mitte)  pos = linksgewicht + 1;
  if (rechts)         pos += 1 + linksgewicht; 
  *gewicht = linksgewicht + rechtsgewicht + 1;
}

void pra() {     /* print all elements of array a[] */
  int i;
  for(i=0;i<8*$;i++);  /*delay loop*/
  prIln(a[$]);
}
